<!---+
--->
<cfcomponent extends="Controller" output="false">

	<cfimport taglib="/com/stellr/tags/cache" prefix="c">
	
	<cffunction name="Index" access="remote" returntype="any" output="false">
		<cfargument name="params" type="any" required="true">
		
		<cfset runSubRequest(controller=getName(),action="List")>
	</cffunction>
	
	<cffunction name="View" access="remote" returntype="any" output="false">
		<cfargument name="params" type="any" required="true">
		
		<cfset var event = params.get("event")>
		<cfset var commentForm = newObject("models.forms.CommunityCommentForm").init()>
		<cfset var speaker = "">
		<cfset var linkId = "">
		
		<cfif params.isNotEmpty("linkId")>
			<cfset speaker = getModel("attendee.Attendee").get(id=val(listFirst(params.get("linkId"),"-")))>
		<cfelse>
			<cfset speaker = getModel("attendee.Attendee").get(id=val(params.get("id")))>
		</cfif>
				
		<cfif not speaker.getIsPersisted() or not speaker.getPackage().getParentEvent().equalsObject(event)>
			<cfset redirect(urlFor(controller=getName(),action="list"))>
		</cfif>
		
		<cfif not speaker.isSpeaker()>
			<cfset redirect(urlFor(controller="attendees",action="view",linkId=speaker.getLinkId()))>
		</cfif>
		
		<cfif speaker.getLinkId() neq params.get("linkId") and listFindNoCase("cfm,html",params.get("format"))>
			<cfset redirect(urlFor(controller=getName(),action="view",linkId=speaker.getLinkId()))>
		</cfif>
		
		<cfset params.set("commentForm",commentForm)>
		<cfset params.set("speaker",speaker)>
	</cffunction>
	
	<cffunction name="Comment" access="remote" returntype="any" output="false">
		<cfargument name="params" type="any" required="true">
		
		<cfset var event = params.get("event")>
		<cfset var speaker = getModel("attendee.Attendee").get(id=val(params.get("id")))>
		<cfset var commentForm = newObject("models.forms.CommunityCommentForm").init()>
		<cfset var comment = "">
		
		<cfset params.set("commentForm",commentForm)>
		<cfset params.set("speaker",speaker)>
		
		<cfif not speaker.getIsPersisted() or not speaker.isSpeaker() or not speaker.getPackage().getParentEvent().equalsObject(event)>
			<cfset redirect(urlFor(controller=getName(),action="list"))>
		</cfif>
		
		<cfset commentForm.process(params)>
		
		<cfif not commentForm.hasAnyErrors()>
			<cfset comment = commentForm.createComment()>
			<cfset comment.save()>
			<cfset speaker.addComment(comment)>
			<cfset speaker.save()>
			
			<cfset params.set("comment",comment)>
			<cfset params.set("mailTo",params.get("MailNotificationsTo"))>
			<cfset renderEmail("comment")>
			
			<cfset redirect(urlFor(controller=getName(),action='view',linkId=speaker.getLinkId()))>
		<cfelse>
			<cfset renderView("view")>
		</cfif>
	</cffunction>
	
	<cffunction name="List" access="remote" returntype="any" output="false">
		<cfargument name="params" type="any" required="true">
		
		<cfset var event = params.get("event")>
		<cfset var speakers = "">
		
		<c:CachedRecordSet variable="speakers" key="com.cfunited/2010/speakers">
			<cfset speakers = event.createSpeakerRecordSet()>
			<cfset speakers.load()>
		</c:CachedRecordSet>
		
		<cfset params.set("speakers",speakers)>
	</cffunction>
	
</cfcomponent>