<cfscript>
	import algorithms.Utils;
	import algorithms.sorting.SortAlgorithms;
	
	Utils = new Utils();
	SortAlgorithms = new SortAlgorithms();
	
	// Basic example, easy to sort an array of numbers
	Utils.demoStart("ArraySort");
	list = Utils.randArray(size=10);
	arraySort(list,"numeric");
	Utils.demoEnd([list]);
	
	// Sort like a query
	Utils.demoStart("KeySort");
	list = [{x=1,y=5},{x=0,y=3},{x=1,y=7},{x=0,y=1},{x=5,y=5}];
	list = SortAlgorithms.keySort(list,["x","y"]);
	Utils.demoEnd([list]);
	
	// Sort like a structure
	Utils.demoStart("StructArraySort");
	list = [{x=1,y=5},{x=0,y=3},{x=1,y=7},{x=0,y=1},{x=5,y=5}];
	list = SortAlgorithms.structArraySort(list,"text","x");
	Utils.demoEnd([list]);
	
	// Sort like a query
	Utils.demoStart("QuerySort");
	list = [{x=1,y=5},{x=0,y=3},{x=1,y=7},{x=0,y=1},{x=5,y=5}];
	list = SortAlgorithms.querySort(list,["y asc", "x desc"]);
	Utils.demoEnd([list]);
		
	// QuickSort(), Simple Comparator
	Utils.demoStart("QuickSort Numbers");
	list = Utils.randArray(size=10);
	list = SortAlgorithms.quickSort(list,Utils.numericComparator);
	Utils.demoEnd([list]);
	
	// QuickSort(), Complex Comparator
	//arraySort(list,"complex???");
	Utils.demoStart("QuickSort Complex Comparator");
	list = [{x=1,y=[1,2,3]},{x=0,y=[3,2]},{x=1,y=[1,0]},{x=0,y=[0,1]}];
	// First sort by "x" property, then look at "y" property
	function complexComparator(a,b)
	{
		var result = a.x-b.x;
		
		if( result )
			return result;
			
		for(var i=1; i <= arrayLen(a.y); ++i)
		{
			if( i > arrayLen(b.y) )
				return -1;
			
			result = a.y[i]-b.y[i];
			
			if( result )
				return result;
		}
	}
	list = SortAlgorithms.quickSort(list,complexComparator);
	Utils.demoEnd([list]);	
</cfscript>